/*
 * getopt - parse command-line options
 */
/* $Header: getopt.c,v 1.1 89/12/18 14:39:31 eck Exp $ */
/*
 * From minix source code
 * getopt reset by spd@daphne.cps.unizar.es
 */

#include <stdlib.h>
#include <string.h>
#include <stdio.h>

#define ERR(s, c)       if(opterr){\
        fputs(argv[0], stderr);\
        fputs(s, stderr);\
        fputc(c, stderr);\
        fputc('\n', stderr);}

#define opterr Opterr
#define optind Optind
#define optopt Optopt
#define optarg Optarg
#define getopt Getopt
#define getoptreset Getoptreset

int     opterr = 1;
int     optind = 1;
static  int sp = 1;
int     optopt;
char    *optarg;


void getoptreset(void)
{
	opterr = 1;
	optind = 1;
	sp = 1;
}

int getopt( int argc, char **argv, char *opts)
{
        register c;
        register char *cp;

        if (sp == 1)
                if (optind >= argc ||
                   argv[optind][0] != '-' || argv[optind][1] == '\0')
                        return EOF;
                else if (!strcmp(argv[optind], "--")) {
                        optind++;
                        return EOF;
                }
        optopt = c = argv[optind][sp];
        if (c == ':' || (cp=strchr(opts, c)) == NULL) {
                ERR (": illegal option -- ", c);
                if (argv[optind][++sp] == '\0') {
                        optind++;
                        sp = 1;
                }
                return '?';
        }
        if (*++cp == ':') {
                if (argv[optind][sp+1] != '\0')
                        optarg = &argv[optind++][sp+1];
                else if (++optind >= argc) {
                        ERR (": option requires an argument -- ", c);
                        sp = 1;
                        return '?';
                } else
                        optarg = argv[optind++];
                sp = 1;
        } else {
                if (argv[optind][++sp] == '\0') {
                        sp = 1;
                        optind++;
                }
                optarg = NULL;
        }
        return c;
}
